#!/usr/bin/perl
# 
# plugin - em_srch 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

# sb.cgi ѻ˸ɽˤƸζĴԤץ饰
# {entry_description}, {entry_excerpt} 񤭤ޤ
# 
# {entry_excerpt} ϸƤǤ礬褦ʸ
# ȴФԤޤ

sub plugin_init {
	$gEnv{'plugin'}{$_[0]} = {
		'name'    => '&#x691C;&#x7D22;&#x8A9E;&#x53E5;&#x5F37;&#x8ABF;',
		'version' => '0.01',
		'author'  => 'takkyun',
		'link'    => 'http://serenebach.net/',
		'type'    => 'cms_entry',
		'func'    => \&sbemsrch_search_word,
		'conf'    => {
			'bgn' => '<strong>',  # ĴɽѤ볫ϥ
			'end' => '</strong>', # ĴɽѤ뽪λ
			'len' => 200,         # {entry_excerpt} ǤȴФĹ
		},
	};
}
sub sbemsrch_search_word {
	my ($eid,$num,$mode) = @_; # ϥѥ᡼ / $eid : ID , $num : ֥åֹ , $mode : ϥ⡼
	my $self = &sbemsrch_check_myself();
	return() if ($gIn{'search'} eq '' or $mode eq 'ent'); # ⡼ɤǤϤʤˤϲ⤷ʤ
	my $aAscii      = '[\x00-\x7F]';
	my $aTwoBytes   = '[\x8E\xA1-\xFE][\xA1-\xFE]';
	my $aThreeBytes = '\x8F[\xA1-\xFE][\xA1-\xFE]';
	my $aWordBgn    = $gEnv{'plugin'}{$self}{'conf'}{'bgn'};
	my $aWordEnd    = $gEnv{'plugin'}{$self}{'conf'}{'end'};
	my $data = $gData{'entry'}{$eid}{'ent'};
	my $word = $gIn{'search'};
	my $body = &sbtxt_det($$data{'body'});
	my $summ = $$data{'body'} . $$data{'more'};
	$body = &sbcms_text_format($body,$$data{'form'});
	if ($gEnv{'code'} ne 'euc') {
		$body = &sblang_conv($body,'euc',$gEnv{'code'});
		$summ = &sblang_conv($sum,'euc',$gEnv{'code'});
	}
	$summ = &sbemsrch_make_summary($summ,$gEnv{'plugin'}{$self}{'conf'}{'len'});
	$body =~ s/\G((?:$aAscii|$aTwoBytes|$aThreeBytes)*?)((?:$word))/$1$aWordBgn$2$aWordEnd/ig;
	$summ =~ s/\G((?:$aAscii|$aTwoBytes|$aThreeBytes)*?)((?:$word))/$1$aWordBgn$2$aWordEnd/ig;
	if ($gEnv{'code'} ne 'euc') {
		$body = &sblang_conv($body,$gEnv{'code'},'euc');
		$summ = &sblang_conv($sum,$gEnv{'code'},'euc');
	}
	$gData{'{entry_description}'}[$num] = $body;
	$gData{'{entry_excerpt}'}[$num]     = $summ;
	return();
}
sub sbemsrch_check_myself {
	my $self = __FILE__;
	$self =~ s/.*[:\/\\](.*)/$1/;
	return($self);
}
sub sbemsrch_make_summary {
	my ($text,$len) = @_;
	$text = &sbtxt_lfconv(&sbtxt_det($text),1);
	$text = &sbtxt_rmvtag($text,'euc');
	$text = &sbemsrch_body_cut($text,$gIn{'search'},index(lc($text),lc($gIn{'search'})),$len) if (length($text) > $len);
	return($text);
}
sub sbemsrch_body_cut { # ʸĹĴ
	my ($text,$word,$check,$len) = @_; # ϥѥ᡼
	my $aTmpAbbr = '...';
	$check = &sbemsrch_search_location(lc($text),lc($word),$check) if ($check > 0);
	$check = ($check <= ($len / 2)) ? 0 : $check - int($len / 2);
	$text = &sbtxt_clip($text,$check,$len,'euc') . $aTmpAbbr;
	$text = $aTmpAbbr . $text if ($check > 0);
	return($text);
}
sub sbemsrch_search_location { # ΰָ
	my ($text,$word,$check) = @_; # ϥѥ᡼
	my ($find) = ();              # ϥѥ᡼
	my @location;                 # ѥ᡼
	while ($check >= 0) {
		push(@location,$check);
		$check = index($text,$word,$check+1);
	}
	foreach (@location) {
		my $tmp = substr($text,0,$_);
		if (!($tmp =~ /\x8F$/ or $tmp =~ tr/\x8E\xA1-\xFE// % 2)) {
			$find = $_;
			last;
		}
	}
	return($find);
}
1;
# Ρ1;פ˺ʤ褦ˤޤ礦줬ʤ require Ǥޤ
